package com.muzhi.tianhe;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.aliwork.YDSearch;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilMap;
import com.muzhi.tianhe.service.AccessTokenService;
import com.muzhi.tianhe.service.TbService;
import com.muzhi.tianhe.service.ThTbService;
import com.muzhi.tianhe.service.impl.TbApiService;
import com.muzhi.tianhe.util.PublicUtil;
import lombok.extern.slf4j.Slf4j;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;
import org.apache.commons.lang3.StringUtils;
import org.joda.time.DateTimeUtils;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;
import java.time.format.DateTimeParseException;
import java.util.*;
import java.util.stream.Collectors;

@Slf4j
@SpringBootTest(classes = TianHeApplication.class)
public class TbTest {

    @Autowired
    private TbService tbService;
    @Autowired
    private TbApiService tbApiService;
    @Autowired
    private ThTbService thTbService;

    @Test
    public void test(){
        try {
//            tbService.removeTianhe();
//            tbService.getXiangmu();
//            List users=tbService.projectMember("65eefe214f2eb1fe4e88b557");
//            log.info("u:{}",users);
//            tbService.test();
//            tbService.getDingUserId("");
            tbService.asyncXm("66e3f8b0ebdbe2340552e91c");
//            Thread.sleep(1000*60);
//            JSONArray array=tbApiService.getProjectState("65efed344f2eb1fe4e88c81f");
//            System.out.println(array);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private String data="{\"created\":\"2024-06-25T03:05:18.778Z\",\"creatorId\":\"65b1dc8355d0f38026a1c3db\",\"customfieldId\":\"65b9e3af475c2137f56d572d\",\"customfieldOldValue\":[],\"customfieldType\":\"lookup\",\"customfieldValue\":[{\"id\":\"65b1dc8355d0f38026a1c3db\",\"title\":\"顾虎臣\"}],\"taskId\":\"667127e4a830bd315b3baf44\",\"updated\":\"2024-06-25T03:05:18.778Z\"}";

    @Autowired
    private YDClient ydClient;

    @Test
    public void tbTest(){
        String taskId="66712bd9257b3dca3cf99296";
        thTbService.task(taskId,"0",JSONObject.parseObject(data));
    }

    //ALTER TABLE `tianhe`
    //ADD COLUMN `glxiangmubianhao`  varchar(255) NULL AFTER `taskid`,
    //ADD COLUMN `glshuoshupingtai`  varchar(255) NULL AFTER `taskid`,
    //ADD COLUMN `glxiangmuguishu`  varchar(255) NULL AFTER `taskid`,
    //ADD COLUMN `glxiangmujibie`  varchar(255) NULL AFTER `taskid`,
    //ADD COLUMN `glsjlcy`  varchar(255) NULL AFTER `taskid`,
    //ADD COLUMN `glchengbenzhongxin`  varchar(255) NULL AFTER `taskid`,
    //ADD COLUMN `glxiangmuyusuan`  varchar(255) NULL AFTER `taskid`,
    //ADD COLUMN `glyusuanzhixingqingkuang`  varchar(255) NULL AFTER `taskid`,
    //ADD COLUMN `glsfsygjrwfj`  varchar(255) NULL AFTER `taskid`,
    //ADD COLUMN `glguanjianrenwumingcheng`  varchar(255) NULL AFTER `taskid`,
    //ADD COLUMN `glxiangmugongqi`  varchar(255) NULL AFTER `taskid`,
    //ADD COLUMN `glxiangmumubiao`  text NULL AFTER `taskid`,
    //ADD COLUMN `glxiangmujiazhi`  text NULL AFTER `taskid`,
    //ADD COLUMN `glxiangmufanwei`  text NULL AFTER `taskid`,
    //ADD COLUMN `glxiangmushishicelue`  text NULL AFTER `taskid`,
    //ADD COLUMN `glxiangmujili`  text NULL AFTER `taskid`,
    //ADD COLUMN `glxiangmuzhuyaofengxian`  text NULL AFTER `taskid`;

    @Test
    public void syncStatus(){
        thTbService.syncState();
//        thTbService.syncStateProject("66651dd9abba8250461819d6");
//        String a=tbApiService.getUserId("153620324221442254",false);
//        System.out.println(a);

//        String projectId="66e3f8b0ebdbe2340552e91c";
//        JSONObject project=tbApiService.getProjectInfo(projectId).getJSONObject(0);
//        boolean projectEnd=isFuture(project.getString("endDate")); // 项目是否未结束
//        JSONObject state=getProjectState(projectId);
//        String stageName=state.getString("name");
//        String degree=state.getString("degree");
//        if(!projectEnd&&degree.equals("normal")){
//            // 结束且绿灯
//            return;
//        }
//        // 判断项目是否截止
//        // 查询项目下任务列ID
//        String stageId=tbApiService.getStageId(projectId,stageName).getJSONObject(0).getString("id");
//        // 查询项目下任务
//        List<Map> list=tbApiService.getTasksByStageId(projectId,stageId).toJavaList(Map.class);
//        // 循环判断任务是否逾期
//        list=list.stream().filter(item -> UtilMap.getBoolean(item,"isDone") == false &&
//                isFuture(UtilMap.getString(item,"dueDate")) == false
//        ).collect(Collectors.toList());
//        if(list!=null&&list.size()>0){
//            // 任务有逾期情况
//            if(degree.equals("normal")){
//                if(projectEnd){
//                    // 项目未结束
//                    tbApiService.addProjectState(projectId,UtilMap.map("degree, content, name","risky","逾期",stageName)); // 状态绿灯修改为黄灯
//                }else{
//                    // 项目结束
//                    tbApiService.addProjectState(projectId,UtilMap.map("degree, content, name","risky","项目结束逾期",stageName)); // 状态绿灯修改为红灯
//                }
//            }else if(degree.equals("risky")){
//                if(projectEnd){
//
//                }else{
//                    // 项目结束
//                    tbApiService.addProjectState(projectId,UtilMap.map("degree, content, name","risky","项目结束逾期",stageName)); // 状态黄灯修改为红灯
//                }
//            }
//        }else{
//            // 任务没逾期情况
//            if(degree.equals("risky")){
//                tbApiService.addProjectState(projectId,UtilMap.map("degree, content, name","normal","正常",stageName)); // 状态黄灯修改为绿灯
//            }
//        }
    }

    /**
     * 判断给定的时间字符串表示的时间是否在未来（即是否大于当前时间）。
     *
     * @param timeStr 时间字符串，格式为 "2024-09-11T10:00:00.000Z"
     * @return 如果给定的时间在未来则返回 true，否则返回 false。
     */
    public static boolean isFuture(String timeStr) {
        if(StringUtils.isBlank(timeStr)){
            return true;
        }
        // 定义日期时间格式器
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        try {
            // 解析时间字符串为 LocalDateTime 对象
            LocalDateTime localDateTime = LocalDateTime.parse(timeStr, formatter);
            // 获取当前时间的 LocalDateTime 对象（以 UTC 时区）
            LocalDateTime now = LocalDateTime.now(ZoneId.of("UTC"));
            // 比较给定的时间与当前时间
            return localDateTime.isAfter(now);
        } catch (DateTimeParseException e) {
            // 如果时间字符串格式不正确，则抛出异常
            throw new IllegalArgumentException("Invalid date format: " + timeStr, e);
        }
    }

    /***
     * 获取项目状态
     * @param projectId
     * @return
     */
    public JSONObject getProjectState(String projectId) {
        try {
            JSONArray array=tbApiService.getProjectState(projectId);
            if(array!=null&&array.size()>0){
                return array.getJSONObject(0);
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }



}
